//
// GLSL hatch fragment shader (based on D3D example in RenderMonkey)
//

varying vec3	weights0;
varying vec3	weights1;
varying vec4	clr;

uniform sampler2D hatchMap0;
uniform sampler2D hatchMap1;
uniform sampler2D hatchMap2;
uniform sampler2D hatchMap3;
uniform sampler2D hatchMap4;
uniform sampler2D hatchMap5;

void main (void)
{
	vec4 hatchTex0 = texture2D ( hatchMap0, gl_TexCoord [0].xy );
	vec4 hatchTex1 = texture2D ( hatchMap1, gl_TexCoord [0].xy );
	vec4 hatchTex2 = texture2D ( hatchMap2, gl_TexCoord [0].xy );
	vec4 hatchTex3 = texture2D ( hatchMap3, gl_TexCoord [0].xy );
	vec4 hatchTex4 = texture2D ( hatchMap4, gl_TexCoord [0].xy );
	vec4 hatchTex5 = texture2D ( hatchMap5, gl_TexCoord [0].xy );

	gl_FragColor = hatchTex0 * weights0.x + hatchTex1 * weights0.y +
                   hatchTex2 * weights0.z + hatchTex3 * weights1.x +
                   hatchTex4 * weights1.y + hatchTex5 * weights1.z;
}

