//
// GLSL hatch vertex shader (based on D3D example in RenderMonkey)
//

varying vec3	weights0;
varying vec3	weights1;
varying vec4	clr;

uniform	vec4	lightPos;
uniform	vec4	eyePos;

void main(void)
{
	vec3	p = vec3 ( gl_ModelViewMatrix * gl_Vertex );	// transformed point to world space
	vec3    l = normalize ( vec3 ( lightPos ) - p );		// vector to light source
	vec3    n = normalize ( gl_NormalMatrix * gl_Normal );	// transformed n
	float   diffuse = 0.3 + min ( 1.0, max ( 0.0, dot ( l, n ) ) );
	float	hatch   = 6.0 * diffuse;

clr = vec4 ( vec3 ( hatch / 6.0 ), 1.0 );

	weights0 = vec3 ( 0.0 );
	weights1 = vec3 ( 0.0 );

	if ( hatch > 5.0 )
		weights0.x = 1.0;
	else
	if ( hatch > 4.0 )
	{
		weights0.x = 1.0 - (5.0 - hatch);
		weights0.y = 1.0 - weights0.x;
	}
	else
	if ( hatch > 3.0 )
	{
		weights0.y = 1.0 - (4.0 - hatch);
		weights0.z = 1.0 - weights0.y;
	}
	else
	if ( hatch > 2.0 )
	{
		weights0.z = 1.0 - (3.0 - hatch);
		weights1.x = 1.0 - weights0.z;
	}
	else
	if ( hatch > 1.0 )
	{
		weights1.x = 1.0 - (2.0 - hatch);
		weights1.y = 1.0 - weights1.x;
	}
	else
	if ( hatch > 0.0 )
	{
		weights1.y = 1.0 - (1.0 - hatch);
		weights1.z = 1.0 - weights1.y;
	}

	gl_Position = gl_ModelViewProjectionMatrix * gl_Vertex;
	gl_TexCoord [0] = gl_MultiTexCoord0;
}
